#include <bits/stdc++.h>

using namespace std;
using nagai = long long;
using db = long double;

struct vt
{
	db x, y;
	vt(){}
	vt(db x, db y)
		: x(x), y(y)
	{}
	vt operator -(vt b)
	{
		return vt(x - b.x, y - b.y);
	}
	vt operator +(vt b)
	{
		return vt(x + b.x, y + b.y);
	}
	vt operator *(db b)
	{
		return vt(x * b, y * b);
	}
	db operator %(vt b)
	{
		return x * b.y - y * b.x;
	}
	db operator *(vt b)
	{
		return x * b.x + y * b.y;
	}
	bool operator <(vt b)
	{
		if (x != b.x)
			return x < b.x;
		return y < b.y;
	}
	bool operator !=(vt b)
	{
		return x != b.x || y != b.y;
	}

};

using pol = vector<vt>;

db area(pol p)
{
	db ans = 0;
	for (int i = 0; i < p.size(); ++i)
	{
		int j = i + 1 == p.size() ? 0 : i + 1;
		ans += p[i] % p[j];
	}
	return abs(ans) / 2;
}

pol cht1(pol a)
{
	pol mem;
	for (auto& v : a)
	{
		while (mem.size() > 2 && (v - mem[mem.size() - 2]) % (mem.back() - mem[mem.size() - 2]) >= 0)
			mem.pop_back();
		mem.push_back(v);
	}
	return mem;
}

pol cht(pol a)
{
	sort(a.begin(), a.end());
	pol ans = cht1(a);
	ans.pop_back();
	reverse(a.begin(), a.end());
	pol ans1 = cht1(a);
	for (auto& v : ans1)
		ans.push_back(v);
	ans.pop_back();
	return ans;
}

vt inters(vt a, vt b, vt c, vt d)
{
	db ma = (c - b) % (d - b);
	db mb = (d - a) % (c - a);
	return (a * ma + b * mb) * (1 / (ma + mb));
}

vt kekos = {-239, 1488};

db eps = 1e-9;

vt inters_segs(vt a, vt b, vt c, vt d)
{
	if ((b - a) % (d - c) == 0)
		return kekos;
	vt lol = inters(a, b, c, d);
	if (min(a.x, b.x) - eps <= lol.x && lol.x <= max(a.x, b.x) + eps && min(a.y, b.y) - eps <= lol.y && lol.y <= max(a.y, b.y) + eps)
		return lol;
	return kekos;
}

bool inside(vt a, pol b)
{
	db area = 0;
	for (int i = 0; i < b.size(); ++i)
	{
		int j = i + 1 == b.size() ? 0 : i + 1;
		area += (b[i] - a) % (b[j] - a);
	}
	return area > 0;
}

pol inter(pol ft, pol sd)
{
	pol memos;
	for (int i = 0; i < ft.size(); ++i)
		for (int j = 0; j < sd.size(); ++j)
		{
			vt a = ft[i];
			vt b = ft[i + 1 == ft.size() ? 0 : i + 1];
			vt c = sd[j];
			vt d = sd[j + 1 == sd.size() ? 0 : j + 1];
			vt lol = inters_segs(a, b, c, d);
			if (lol != kekos)
				memos.push_back(lol);
		}
	for (auto& x : ft)
		if (inside(x, sd))
			memos.push_back(x);
	for (auto& x : sd)
		if (inside(x, ft))
			memos.push_back(x);
	return cht(memos);
}

db score(pol a, pol b)
{
	return area(inter(a, b));
}

pair<db, db> mnmxy(pol p, db x)
{
	db mn = 1e18, mx = -1e18;
	for (int i = 0; i < p.size(); ++i)
	{
		int j = i + 1 == p.size() ? 0 : i + 1;
		if (abs(p[i].x - x) < eps)
			mn = min(mn, p[i].y), mx = max(mx, p[i].y);
		auto mem = inters_segs(p[i], p[j], vt(x, 0), vt(x, 1));
		if (mem != kekos)
			mn = min(mn, mem.y), mx = max(mx, mem.y);
	}
	return {mn, mx};
}

db dist(vt a, vt b)
{
	return hypot(a.x - b.x, a.y - b.y);
}

db dist(vt a, vt b, vt c)
{
	if ((a - c) * (b - c) < 0)
		return dist(a, c);
	if ((a - b) * (c - b) < 0)
		return dist(a, b);
	return abs(((c - a) % (b - a)) / dist(b, c));
}

db dist(pol a, pol b)
{
	db ans = 1e18;
	for (int i = 0; i < a.size(); ++i)
		for (int j = 0; j < b.size(); ++j)
		{
			int i1 = i + 1 == a.size() ? 0 : i + 1;
			int j1 = j + 1 == b.size() ? 0 : j + 1;
			ans = min(ans, dist(a[i], b[j], b[j1]));
			ans = min(ans, dist(b[j], a[i], a[i1]));
		}
	return ans;

}

db calc(pol a, pol b, db y)
{
	for (auto& mem : b)
		mem.y += y;
	return dist(a, b);
}

db pep(pol a, pol b, db x)
{
	for (auto& mem : b)
		mem.x += x;
	db mny = -1e18;
	db mxy = 1e18;
	for (auto& x : b)
	{
		auto lol = mnmxy(a, x.x);
		auto lol1 = mnmxy(b, x.x);
		if (lol.first > 1e9 || lol1.first > 1e9)
			continue;
		// lf <= l1f + sh <= l1s + sh <= ls
//		lol.first <= lol1.pirst + y
		// lol1.first - lol.first >= -y
		// mny = max(mny, lol1.first - lol.first)
		// l1s + y <= ls
		// y <= ls - l1.second
//		cerr << x.x lol1.first << ' ' << lol.first << '\n';
		mxy = min(mxy, lol.second - lol1.second);
		mny = max(mny, lol.first - lol1.first);
	}
	for (auto& x : a)
	{
		auto lol = mnmxy(a, x.x);
		auto lol1 = mnmxy(b, x.x);
		if (lol.first > 1e9 || lol1.first > 1e9)
			continue;
		mxy = min(mxy, lol.second - lol1.second);
		mny = max(mny, lol.first - lol1.first);
	}
	return mxy - mny;
}

db chle(pol a, pol b, db x)
{
	for (auto& mem : b)
		mem.x += x;
	db mny = -1e18;
	db mxy = 1e18;
	for (auto& x : b)
	{
		auto lol = mnmxy(a, x.x);
		auto lol1 = mnmxy(b, x.x);
		if (lol.first > 1e9 || lol1.first > 1e9)
			continue;
		// lf <= l1f + sh <= l1s + sh <= ls
//		lol.first <= lol1.pirst + y
		// lol1.first - lol.first >= -y
		// mny = max(mny, lol1.first - lol.first)
		// l1s + y <= ls
		// y <= ls - l1.second
//		cerr << x.x lol1.first << ' ' << lol.first << '\n';
		mxy = min(mxy, lol.second - lol1.second);
		mny = max(mny, lol.first - lol1.first);
	}
	for (auto& x : a)
	{
		auto lol = mnmxy(a, x.x);
		auto lol1 = mnmxy(b, x.x);
		if (lol.first > 1e9 || lol1.first > 1e9)
			continue;
		mxy = min(mxy, lol.second - lol1.second);
		mny = max(mny, lol.first - lol1.first);
	}
	db L = mny, R = mxy;
	for (int i = 0; i < 75; ++i)
	{
		db M1 = (2 * L + R) / 3;
		db M2 = (L + 2 * R) / 3;
		if (calc(a, b, M1) < calc(a, b, M2))
			L = M1;
		else
			R = M2;
	}
	return calc(a, b, L);
}

ostream& operator <<(ostream& a, vt b)
{
	return a << b.x << ' ' << b.y << '\n';
}

int main()
{
	/*
	cerr << dist(vt(0, 0), vt(0, 1), vt(1, 0)) << '\n';
	cerr << dist(vt(0, 0), vt(1, 1), vt(1, 2)) << '\n';
	return 0;
	*/
	int n;
	cin >> n;
	pol a(n);
	for (auto& x : a)
		cin >> x.x >> x.y;
	int m;
	cin >> m;
	pol b(m);
	for (auto& x : b)
		cin >> x.x >> x.y;
	db a_r = -1e9, a_l = 1e9;
	db b_r = -1e9, b_l = 1e9;
	for (auto &x : a) a_l = min(a_l, x.x), a_r = max(a_r, x.x);
	for (auto &x : b) b_l = min(b_l, x.x), b_r = max(b_r, x.x);
	db vl = a_l - b_r;
	db vr = a_r - b_l;
	db _l = vl, _r = vr;
	for (int it = 0; it < 100; it++)
	{
		db m1 = (vl + vl + vr) / 3;
		db m2 = (vl + vr + vr) / 3;
		if (pep(a, b, m1) < pep(a, b, m2))
		{
			vl = m1;
		}
		else
		{
			vr = m2;
		}
	}
	db mid = (vl + vr) / 2;
	vl = _l, vr = mid;
	for (int it = 0; it < 100; it++)
	{
		db m = (vl + vr) / 2;
		if (pep(a, b, m) >= 0)
		{
			vr = m;
		}
		else
		{
			vl = m;
		}
	}
	db aue = vr;
	vl = mid, vr = _r;
	for (int it = 0; it < 100; it++)
	{
		db m = (vl + vr) / 2;
		if (pep(a, b, m) >= 0)
		{
			vl = m;
		}
		else
		{
			vr = m;
		}
	}
	vr = vl;
	vl = aue;
	for (int it = 0; it < 75; it++)
	{
		db m1 = (vl + vl + vr) / 3;
		db m2 = (vl + vr + vr) / 3;
		if (chle(a, b, m1) < chle(a, b, m2))
		{
			vl = m1;
		}
		else
		{
			vr = m2;
		}
	}
	cout << fixed << setprecision(20) << chle(a, b, (vl + vr) / 2) / 2 << endl;
}
