import java.io.*;
import java.util.*;

public class D {
    String fileName = "<name>";

    public static class Pair implements Comparable<Pair> {
        public int x, ind;

        public Pair(int x, int ind) {
            this.x = x;
            this.ind = ind;
        }

        @Override
        public int compareTo(Pair p) {
            if (x != p.x)
                return Integer.compare(x, p.x);
            return Integer.compare(ind, p.ind);
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        TreeSet<Pair> p = new TreeSet<>();
        for (int i = 0; i < n; i++) {
            p.add(new Pair(nextInt(), i));
        }
        List<Pair> ans = new ArrayList<>(n - 1);
        while (ans.size() != n - 1) {
            Pair max = p.pollLast();
            Pair min = p.pollFirst();
            ans.add(new Pair(max.ind, min.ind));
            max.x--;
            min.x--;
            if (max.x > 0)
                p.add(max);
            if (min.x > 0)
                p.add(min);
        }
        for (int i = 0; i < ans.size(); i++) {
            out.print(ans.get(i).x + 1);
            out.print(' ');
            out.println(ans.get(i).ind + 1);
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }

}
